<?php
namespace Claromentis\Core\User\Directory\Ldap;

$GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"] ?: array()) + array("_3db2b68627d67bdfe07d" . "e458cf5ea3ba" => base64_decode("c3Ryd" . "G91cH" . "Blcg=" . "="), "_ccaa693c4f1737d3b" . "f7611e6c25e1869" => base64_decode("IGlzIGludmFsaWQ" . "="), "_47c50dfc8dc45a6888602c1db1a193" . "a3" => base64_decode("IGlzIG5vdCBpbiBhIHZhb" . "GlkIExEQVAgR2VuZXJhbG" . "lzZWQgVGltZSBmb3JtYXQ" . "="), "_0042b42b94edac45ee" . "46e1c7cc0e21f7" => base64_decode("dX" . "Rj"), "_995fb4acb4a30eab38e7" . "44c36dc6fb4a" => base64_decode("WW" . "1k" . "SG" . "lz"), "_aaabebe7ea4dcd24a8" . "e6b36cfe511422" => base64_decode("VV" . "RD"), "_ca1057ad8fa" . "da1881cc7737" . "d51fcd1af" => base64_decode("VGhlIHRpbWV6b25lIG9mZnNldCA" . "="), "_3947612f1a6969300a6d" . "08deec805277" => base64_decode("Wg" . "=="), "_d155d43a39de93f858" . "123c6b6ce31d8a" => base64_decode("cHJlZ19t" . "YXRjaA=="));
use Claromentis\Core\User\Directory\Exception\InvalidDateException;
use DateTime;
use DateTimeZone;
use Exception;






class GeneralizedTimeParser
{
    
    
    
    
    
    
    
    
    private $regex = '#^(\\d{14})([,.]{1}\\d+)?(Z|z|((\\+|-){1}(\\d{2}|\\d{4})))$#';
    
    
    
    
    private $parsed = null;
    
    
    
    
    private $is_utc = false;
    
    
    
    
    
    private $timezone = null;
    public function __construct($_67a0d624aebcceb0abd5ce56a53ff06f = null)
    {
        if ($_67a0d624aebcceb0abd5ce56a53ff06f) {
            $this->initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f);
        }
    }
    
    
    
    
    
    
    
    public function initWithDate($_67a0d624aebcceb0abd5ce56a53ff06f)
    {
        
        
        $this->parsed = null;
        $this->timezone = null;
        $this->is_utc = false;
        
        
        $_3edeea3a30945de8abb845ca7489c82a = [];
        $GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_d155d43a39de93f858123c6b6ce3" . "1d8a"]($this->regex, $_67a0d624aebcceb0abd5ce56a53ff06f, $_3edeea3a30945de8abb845ca7489c82a);
        if (empty($_3edeea3a30945de8abb845ca7489c82a)) {
            throw new InvalidDateException($_67a0d624aebcceb0abd5ce56a53ff06f . $GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"]["_47c50dfc8dc45a688860" . "2c1db1a193a3"]);
        }
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        if ($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_3db2b68627d67bdfe07de458" . "cf5ea3ba"]($_3edeea3a30945de8abb845ca7489c82a[3]) === $GLOBALS["__65da1b1ec2d6653e8a0ab78" . "48e536215"]["_3947612f1a6" . "969300a6d08d" . "eec805277"]) {
            $this->is_utc = true;
            $this->timezone = new DateTimeZone($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["_0042b42b94edac4" . "5ee46e1c7cc0e21f" . "7"]);
        }
        if (!$this->is_utc && isset($_3edeea3a30945de8abb845ca7489c82a[4])) {
            try {
                $this->timezone = new DateTimeZone($_3edeea3a30945de8abb845ca7489c82a[4]);
            } catch (Exception $_fe441aa3ef350bfb1a1a1ad8520dd530) {
                throw new InvalidDateException($GLOBALS["__65da1b1ec2d665" . "3e8a0ab7848e5362" . "15"]["_ca1057ad8" . "fada1881cc" . "7737d51fcd" . "1af"] . $_3edeea3a30945de8abb845ca7489c82a[4] . $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_ccaa693c4f1737d" . "3bf7611e6c25e186" . "9"]);
            }
        }
        $this->parsed = DateTime::createFromFormat($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_995fb4ac" . "b4a30eab3" . "8e744c36d" . "c6fb4a"], $_3edeea3a30945de8abb845ca7489c82a[1], $this->timezone);
        return $this;
    }
    
    
    
    
    
    
    public function getDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        return clone $this->parsed;
    }
    
    
    
    
    
    
    public function getUTCDate() : ?DateTime
    {
        if (!$this->parsed) {
            return null;
        }
        $_07af7964f51512e67eca70b67f086fce = clone $this->parsed;
        $_07af7964f51512e67eca70b67f086fce->setTimezone(new DateTimeZone($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_aaabebe7ea4dcd24a8" . "e6b36cfe511422"]));
        return $_07af7964f51512e67eca70b67f086fce;
    }
    
    
    
    
    
    
    public function isUTC() : bool
    {
        return $this->is_utc;
    }
}